
(* lexical analyzer template (TP Lex V3.0), V1.0 3-2-91 AG *)

(* global definitions: *)
{***********************************************************}
{   This file is part of the DORB project.                  }
{                                                           }
{   See the file License, included in this distribution,    }
{   for details about the copyright.                        }
{                                                           }
{   Send comments and/or bug reports to: vic@inec.ru        }
{***********************************************************}
unit cpp;
interface
uses
  classes,windows,sysutils,lexlib,yacclib;

  function yylex: integer;

var
  includes : TStringList;
  defined  : TStringList;
  _enabled : array[0..100] of boolean;
  stack_pos : integer;
  disabled_at : integer;

implementation

procedure include_file(const fname: string; local: boolean); forward;
function enabled : Boolean; forward;
procedure _define(val: string); forward;
procedure _undef(val: string); forward;
procedure _ifdef(val: string); forward;
procedure _ifndef(val: string); forward;
procedure _endif; forward;
procedure _else; forward;
procedure _print; forward;



const INCLUDE = 2;
const LOCAL = 4;
const FAR = 6;
const COMMENT = 8;


function yylex : Integer;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)

begin
  (* actions: *)
  case yyruleno of
  1:
                       yyprintln;
  2:
                       start(COMMENT);
  3:
                       ;
  4:
                       begin
                         yyprintln;
                         start(0);
                       end;
  5:
                       start(0);
  6:
                       ;
  7:
                       yyprintln;
  8:
                       start(LOCAL);
  9:
                       start(FAR);
  10:
                       include_file(copy(yytext,1,pos('"',yytext)-1),true);
  11:
                       include_file(copy(yytext,1,pos('>',yytext)-1),false);
  12:
                       _define(trim(copy(yytext,8,100)));
  13:
                       _undef(trim(copy(yytext,7,100)));
  14:
                       _ifdef(trim(copy(yytext,7,100)));
  15:
                       _ifndef(trim(copy(yytext,8,100)));
  16:
                       _endif;
  17:
                       _else;
  18:
                       start(INCLUDE);
  19:
                       _print;
  end;
end(*yyaction*);

(* DFA table: *)

type YYTRec = record
                cc : set of Char;
                s  : Integer;
              end;

const

yynmarks   = 69;
yynmatches = 69;
yyntrans   = 453;
yynstates  = 193;

yyk : array [1..yynmarks] of Integer = (
  { 0: }
  { 1: }
  { 2: }
  { 3: }
  { 4: }
  { 5: }
  { 6: }
  { 7: }
  { 8: }
  { 9: }
  { 10: }
  19,
  { 11: }
  19,
  { 12: }
  19,
  { 13: }
  8,
  19,
  { 14: }
  9,
  19,
  { 15: }
  19,
  { 16: }
  19,
  { 17: }
  19,
  { 18: }
  19,
  { 19: }
  19,
  { 20: }
  19,
  { 21: }
  6,
  19,
  { 22: }
  6,
  19,
  { 23: }
  6,
  19,
  { 24: }
  7,
  { 25: }
  6,
  19,
  { 26: }
  { 27: }
  2,
  { 28: }
  { 29: }
  { 30: }
  { 31: }
  { 32: }
  { 33: }
  2,
  { 34: }
  { 35: }
  { 36: }
  10,
  { 37: }
  { 38: }
  { 39: }
  { 40: }
  { 41: }
  { 42: }
  2,
  { 43: }
  { 44: }
  { 45: }
  { 46: }
  { 47: }
  { 48: }
  { 49: }
  2,
  3,
  { 50: }
  5,
  { 51: }
  1,
  { 52: }
  { 53: }
  { 54: }
  { 55: }
  { 56: }
  { 57: }
  { 58: }
  { 59: }
  1,
  10,
  { 60: }
  { 61: }
  { 62: }
  { 63: }
  { 64: }
  { 65: }
  { 66: }
  { 67: }
  11,
  { 68: }
  { 69: }
  { 70: }
  { 71: }
  { 72: }
  { 73: }
  { 74: }
  4,
  { 75: }
  { 76: }
  { 77: }
  { 78: }
  { 79: }
  { 80: }
  { 81: }
  { 82: }
  { 83: }
  { 84: }
  { 85: }
  { 86: }
  { 87: }
  { 88: }
  { 89: }
  1,
  11,
  { 90: }
  { 91: }
  { 92: }
  { 93: }
  { 94: }
  { 95: }
  { 96: }
  { 97: }
  { 98: }
  { 99: }
  { 100: }
  { 101: }
  { 102: }
  { 103: }
  { 104: }
  { 105: }
  { 106: }
  { 107: }
  { 108: }
  { 109: }
  { 110: }
  { 111: }
  { 112: }
  { 113: }
  { 114: }
  { 115: }
  { 116: }
  { 117: }
  { 118: }
  { 119: }
  { 120: }
  { 121: }
  { 122: }
  { 123: }
  { 124: }
  17,
  { 125: }
  { 126: }
  { 127: }
  { 128: }
  { 129: }
  { 130: }
  { 131: }
  { 132: }
  10,
  17,
  { 133: }
  { 134: }
  { 135: }
  { 136: }
  { 137: }
  { 138: }
  { 139: }
  { 140: }
  { 141: }
  { 142: }
  { 143: }
  { 144: }
  { 145: }
  16,
  { 146: }
  { 147: }
  { 148: }
  { 149: }
  { 150: }
  { 151: }
  { 152: }
  10,
  16,
  { 153: }
  { 154: }
  { 155: }
  { 156: }
  { 157: }
  { 158: }
  { 159: }
  11,
  17,
  { 160: }
  { 161: }
  13,
  { 162: }
  14,
  { 163: }
  { 164: }
  { 165: }
  { 166: }
  { 167: }
  10,
  13,
  { 168: }
  { 169: }
  10,
  14,
  { 170: }
  { 171: }
  { 172: }
  { 173: }
  { 174: }
  { 175: }
  { 176: }
  { 177: }
  11,
  16,
  { 178: }
  12,
  { 179: }
  15,
  { 180: }
  18,
  { 181: }
  { 182: }
  10,
  12,
  { 183: }
  { 184: }
  10,
  15,
  { 185: }
  18,
  { 186: }
  { 187: }
  11,
  13,
  { 188: }
  11,
  14,
  { 189: }
  { 190: }
  18,
  { 191: }
  11,
  12,
  { 192: }
  11,
  15
);

yym : array [1..yynmatches] of Integer = (
{ 0: }
{ 1: }
{ 2: }
{ 3: }
{ 4: }
{ 5: }
{ 6: }
{ 7: }
{ 8: }
{ 9: }
{ 10: }
  19,
{ 11: }
  19,
{ 12: }
  19,
{ 13: }
  8,
  19,
{ 14: }
  9,
  19,
{ 15: }
  19,
{ 16: }
  19,
{ 17: }
  19,
{ 18: }
  19,
{ 19: }
  19,
{ 20: }
  19,
{ 21: }
  6,
  19,
{ 22: }
  6,
  19,
{ 23: }
  6,
  19,
{ 24: }
  7,
{ 25: }
  6,
  19,
{ 26: }
{ 27: }
  2,
{ 28: }
{ 29: }
{ 30: }
{ 31: }
{ 32: }
{ 33: }
  2,
{ 34: }
{ 35: }
{ 36: }
  10,
{ 37: }
{ 38: }
{ 39: }
{ 40: }
{ 41: }
{ 42: }
  2,
{ 43: }
{ 44: }
{ 45: }
{ 46: }
{ 47: }
{ 48: }
{ 49: }
  2,
  3,
{ 50: }
  5,
{ 51: }
  1,
{ 52: }
{ 53: }
{ 54: }
{ 55: }
{ 56: }
{ 57: }
{ 58: }
{ 59: }
  1,
  10,
{ 60: }
{ 61: }
{ 62: }
{ 63: }
{ 64: }
{ 65: }
{ 66: }
{ 67: }
  11,
{ 68: }
{ 69: }
{ 70: }
{ 71: }
{ 72: }
{ 73: }
{ 74: }
  4,
{ 75: }
{ 76: }
{ 77: }
{ 78: }
{ 79: }
{ 80: }
{ 81: }
{ 82: }
{ 83: }
{ 84: }
{ 85: }
{ 86: }
{ 87: }
{ 88: }
{ 89: }
  1,
  11,
{ 90: }
{ 91: }
{ 92: }
{ 93: }
{ 94: }
{ 95: }
{ 96: }
{ 97: }
{ 98: }
{ 99: }
{ 100: }
{ 101: }
{ 102: }
{ 103: }
{ 104: }
{ 105: }
{ 106: }
{ 107: }
{ 108: }
{ 109: }
{ 110: }
{ 111: }
{ 112: }
{ 113: }
{ 114: }
{ 115: }
{ 116: }
{ 117: }
{ 118: }
{ 119: }
{ 120: }
{ 121: }
{ 122: }
{ 123: }
{ 124: }
  17,
{ 125: }
{ 126: }
{ 127: }
{ 128: }
{ 129: }
{ 130: }
{ 131: }
{ 132: }
  10,
  17,
{ 133: }
{ 134: }
{ 135: }
{ 136: }
{ 137: }
{ 138: }
{ 139: }
{ 140: }
{ 141: }
{ 142: }
{ 143: }
{ 144: }
{ 145: }
  16,
{ 146: }
{ 147: }
{ 148: }
{ 149: }
{ 150: }
{ 151: }
{ 152: }
  10,
  16,
{ 153: }
{ 154: }
{ 155: }
{ 156: }
{ 157: }
{ 158: }
{ 159: }
  11,
  17,
{ 160: }
{ 161: }
  13,
{ 162: }
  14,
{ 163: }
{ 164: }
{ 165: }
{ 166: }
{ 167: }
  10,
  13,
{ 168: }
{ 169: }
  10,
  14,
{ 170: }
{ 171: }
{ 172: }
{ 173: }
{ 174: }
{ 175: }
{ 176: }
{ 177: }
  11,
  16,
{ 178: }
  12,
{ 179: }
  15,
{ 180: }
  18,
{ 181: }
{ 182: }
  10,
  12,
{ 183: }
{ 184: }
  10,
  15,
{ 185: }
  18,
{ 186: }
{ 187: }
  11,
  13,
{ 188: }
  11,
  14,
{ 189: }
{ 190: }
  18,
{ 191: }
  11,
  12,
{ 192: }
  11,
  15
);

yyt : array [1..yyntrans] of YYTrec = (
{ 0: }
  ( cc: [ #1..#9,#11..'.','0'..#255 ]; s: 11),
  ( cc: [ '/' ]; s: 10),
{ 1: }
  ( cc: [ #1..#9,#11..'"','$'..'.','0'..#255 ]; s: 11),
  ( cc: [ '#' ]; s: 12),
  ( cc: [ '/' ]; s: 10),
{ 2: }
  ( cc: [ #1..#9,#11..'!','#'..'.','0'..';','='..#255 ]; s: 11),
  ( cc: [ '"' ]; s: 13),
  ( cc: [ '/' ]; s: 10),
  ( cc: [ '<' ]; s: 14),
{ 3: }
  ( cc: [ #1..#9,#11..'!','$'..'.','0'..';','='..#255 ]; s: 11),
  ( cc: [ '"' ]; s: 13),
  ( cc: [ '#' ]; s: 12),
  ( cc: [ '/' ]; s: 10),
  ( cc: [ '<' ]; s: 14),
{ 4: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 11),
  ( cc: [ ' '..'.','0'..'9','A'..'Z','\','_','a'..'z',
            #128..#239 ]; s: 16),
  ( cc: [ '/' ]; s: 15),
{ 5: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 11),
  ( cc: [ ' '..'"','$'..'.','0'..'9','A'..'Z','\','_',
            'a'..'z',#128..#239 ]; s: 16),
  ( cc: [ '#' ]; s: 17),
  ( cc: [ '/' ]; s: 15),
{ 6: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 11),
  ( cc: [ ' '..'.','0'..'9','A'..'Z','\','_','a'..'z',
            #128..#239 ]; s: 19),
  ( cc: [ '/' ]; s: 18),
{ 7: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 11),
  ( cc: [ ' '..'"','$'..'.','0'..'9','A'..'Z','\','_',
            'a'..'z',#128..#239 ]; s: 19),
  ( cc: [ '#' ]; s: 20),
  ( cc: [ '/' ]; s: 18),
{ 8: }
  ( cc: [ #1..#9,#11..')','+'..'.','0'..#255 ]; s: 23),
  ( cc: [ #10 ]; s: 24),
  ( cc: [ '*' ]; s: 22),
  ( cc: [ '/' ]; s: 21),
{ 9: }
  ( cc: [ #1..#9,#11..'"','$'..')','+'..'.','0'..#255 ]; s: 23),
  ( cc: [ #10 ]; s: 24),
  ( cc: [ '#' ]; s: 25),
  ( cc: [ '*' ]; s: 22),
  ( cc: [ '/' ]; s: 21),
{ 10: }
  ( cc: [ '*' ]; s: 27),
  ( cc: [ '/' ]; s: 26),
{ 11: }
{ 12: }
  ( cc: [ 'd' ]; s: 28),
  ( cc: [ 'e' ]; s: 31),
  ( cc: [ 'i' ]; s: 30),
  ( cc: [ 'u' ]; s: 29),
{ 13: }
{ 14: }
{ 15: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..')','+'..'.','0'..'9','A'..'Z','\','_',
            'a'..'z',#128..#239 ]; s: 34),
  ( cc: [ '*' ]; s: 33),
  ( cc: [ '/' ]; s: 32),
{ 16: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 17: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','f'..'h',
            'j'..'t','v'..'z',#128..#239 ]; s: 34),
  ( cc: [ 'd' ]; s: 37),
  ( cc: [ 'e' ]; s: 40),
  ( cc: [ 'i' ]; s: 39),
  ( cc: [ 'u' ]; s: 38),
{ 18: }
  ( cc: [ ' '..')','+'..'.','0'..'9','A'..'Z','\','_',
            'a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '*' ]; s: 42),
  ( cc: [ '/' ]; s: 41),
  ( cc: [ '>' ]; s: 44),
{ 19: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 20: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','f'..'h',
            'j'..'t','v'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'd' ]; s: 45),
  ( cc: [ 'e' ]; s: 48),
  ( cc: [ 'i' ]; s: 47),
  ( cc: [ 'u' ]; s: 46),
{ 21: }
  ( cc: [ '*' ]; s: 49),
  ( cc: [ '/' ]; s: 26),
{ 22: }
  ( cc: [ '/' ]; s: 50),
{ 23: }
{ 24: }
{ 25: }
  ( cc: [ 'd' ]; s: 28),
  ( cc: [ 'e' ]; s: 31),
  ( cc: [ 'i' ]; s: 30),
  ( cc: [ 'u' ]; s: 29),
{ 26: }
  ( cc: [ #1..#9,#11..#255 ]; s: 26),
  ( cc: [ #10 ]; s: 51),
{ 27: }
{ 28: }
  ( cc: [ 'e' ]; s: 52),
{ 29: }
  ( cc: [ 'n' ]; s: 53),
{ 30: }
  ( cc: [ 'f' ]; s: 54),
  ( cc: [ 'n' ]; s: 55),
{ 31: }
  ( cc: [ 'l' ]; s: 57),
  ( cc: [ 'n' ]; s: 56),
{ 32: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 58),
  ( cc: [ #10 ]; s: 59),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 32),
{ 33: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 34: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 35: }
  ( cc: [ #1..#9,#11..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
{ 36: }
{ 37: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 60),
{ 38: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'m','o'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'n' ]; s: 61),
{ 39: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'m',
            'o'..'z',#128..#239 ]; s: 34),
  ( cc: [ 'f' ]; s: 62),
  ( cc: [ 'n' ]; s: 63),
{ 40: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'k','m','o'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'l' ]; s: 65),
  ( cc: [ 'n' ]; s: 64),
{ 41: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 26),
  ( cc: [ #10 ]; s: 51),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 41),
  ( cc: [ '>' ]; s: 66),
{ 42: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 43: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 44: }
  ( cc: [ #1..#9,#11..#255 ]; s: 44),
  ( cc: [ #10 ]; s: 67),
{ 45: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 68),
{ 46: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'m','o'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'n' ]; s: 69),
{ 47: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'m',
            'o'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'f' ]; s: 70),
  ( cc: [ 'n' ]; s: 71),
{ 48: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'k','m','o'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'l' ]; s: 73),
  ( cc: [ 'n' ]; s: 72),
{ 49: }
{ 50: }
  ( cc: [ #10 ]; s: 74),
{ 51: }
{ 52: }
  ( cc: [ 'f' ]; s: 75),
{ 53: }
  ( cc: [ 'd' ]; s: 76),
{ 54: }
  ( cc: [ 'd' ]; s: 77),
  ( cc: [ 'n' ]; s: 78),
{ 55: }
  ( cc: [ 'c' ]; s: 79),
{ 56: }
  ( cc: [ 'd' ]; s: 80),
{ 57: }
  ( cc: [ 's' ]; s: 81),
{ 58: }
  ( cc: [ #1..#9,#11..#255 ]; s: 58),
  ( cc: [ #10 ]; s: 59),
{ 59: }
{ 60: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'f' ]; s: 82),
{ 61: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'd' ]; s: 83),
{ 62: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'m',
            'o'..'z',#128..#239 ]; s: 34),
  ( cc: [ 'd' ]; s: 84),
  ( cc: [ 'n' ]; s: 85),
{ 63: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a','b','d'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'c' ]; s: 86),
{ 64: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'd' ]; s: 87),
{ 65: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'r','t'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 's' ]; s: 88),
{ 66: }
  ( cc: [ #1..#9,#11..#255 ]; s: 66),
  ( cc: [ #10 ]; s: 89),
{ 67: }
{ 68: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'f' ]; s: 90),
{ 69: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'd' ]; s: 91),
{ 70: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'m',
            'o'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'd' ]; s: 92),
  ( cc: [ 'n' ]; s: 93),
{ 71: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a','b','d'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'c' ]; s: 94),
{ 72: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'd' ]; s: 95),
{ 73: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'r','t'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 's' ]; s: 96),
{ 74: }
{ 75: }
  ( cc: [ 'i' ]; s: 97),
{ 76: }
  ( cc: [ 'e' ]; s: 98),
{ 77: }
  ( cc: [ 'e' ]; s: 99),
{ 78: }
  ( cc: [ 'd' ]; s: 100),
{ 79: }
  ( cc: [ 'l' ]; s: 101),
{ 80: }
  ( cc: [ 'i' ]; s: 102),
{ 81: }
  ( cc: [ 'e' ]; s: 103),
{ 82: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'h','j'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'i' ]; s: 104),
{ 83: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 105),
{ 84: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 106),
{ 85: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'd' ]; s: 107),
{ 86: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'k','m'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'l' ]; s: 108),
{ 87: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'h','j'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'i' ]; s: 109),
{ 88: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 110),
{ 89: }
{ 90: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'h','j'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'i' ]; s: 111),
{ 91: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 112),
{ 92: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 113),
{ 93: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'd' ]; s: 114),
{ 94: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'k','m'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'l' ]; s: 115),
{ 95: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'h','j'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'i' ]; s: 116),
{ 96: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 117),
{ 97: }
  ( cc: [ 'n' ]; s: 118),
{ 98: }
  ( cc: [ 'f' ]; s: 119),
{ 99: }
  ( cc: [ 'f' ]; s: 120),
{ 100: }
  ( cc: [ 'e' ]; s: 121),
{ 101: }
  ( cc: [ 'u' ]; s: 122),
{ 102: }
  ( cc: [ 'f' ]; s: 123),
{ 103: }
  ( cc: [ #1..#9,#11..#255 ]; s: 103),
  ( cc: [ #10 ]; s: 124),
{ 104: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'m','o'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'n' ]; s: 125),
{ 105: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'f' ]; s: 126),
{ 106: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'f' ]; s: 127),
{ 107: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 128),
{ 108: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'t','v'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'u' ]; s: 129),
{ 109: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'f' ]; s: 130),
{ 110: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 131),
  ( cc: [ #10 ]; s: 132),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 110),
{ 111: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'m','o'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'n' ]; s: 133),
{ 112: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'f' ]; s: 134),
{ 113: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'f' ]; s: 135),
{ 114: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 136),
{ 115: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'t','v'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'u' ]; s: 137),
{ 116: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'f' ]; s: 138),
{ 117: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 103),
  ( cc: [ #10 ]; s: 124),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 117),
  ( cc: [ '>' ]; s: 139),
{ 118: }
  ( cc: [ 'e' ]; s: 140),
{ 119: }
  ( cc: [ ' ' ]; s: 141),
{ 120: }
  ( cc: [ ' ' ]; s: 142),
{ 121: }
  ( cc: [ 'f' ]; s: 143),
{ 122: }
  ( cc: [ 'd' ]; s: 144),
{ 123: }
  ( cc: [ #1..#9,#11..#255 ]; s: 123),
  ( cc: [ #10 ]; s: 145),
{ 124: }
{ 125: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 146),
{ 126: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' ' ]; s: 147),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 127: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' ' ]; s: 148),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 128: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'f' ]; s: 149),
{ 129: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'd' ]; s: 150),
{ 130: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 151),
  ( cc: [ #10 ]; s: 152),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 130),
{ 131: }
  ( cc: [ #1..#9,#11..#255 ]; s: 131),
  ( cc: [ #10 ]; s: 132),
{ 132: }
{ 133: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 153),
{ 134: }
  ( cc: [ ' ' ]; s: 154),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 135: }
  ( cc: [ ' ' ]; s: 155),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 136: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'e','g'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'f' ]; s: 156),
{ 137: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'c','e'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'd' ]; s: 157),
{ 138: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 123),
  ( cc: [ #10 ]; s: 145),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 138),
  ( cc: [ '>' ]; s: 158),
{ 139: }
  ( cc: [ #1..#9,#11..#255 ]; s: 139),
  ( cc: [ #10 ]; s: 159),
{ 140: }
  ( cc: [ ' ' ]; s: 160),
{ 141: }
  ( cc: [ #1..#9,#11..#255 ]; s: 141),
  ( cc: [ #10 ]; s: 161),
{ 142: }
  ( cc: [ #1..#9,#11..#255 ]; s: 142),
  ( cc: [ #10 ]; s: 162),
{ 143: }
  ( cc: [ ' ' ]; s: 163),
{ 144: }
  ( cc: [ 'e' ]; s: 164),
{ 145: }
{ 146: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' ' ]; s: 165),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 147: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 166),
  ( cc: [ #10 ]; s: 167),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 147),
{ 148: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 168),
  ( cc: [ #10 ]; s: 169),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 148),
{ 149: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' ' ]; s: 170),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 150: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 34),
  ( cc: [ 'e' ]; s: 171),
{ 151: }
  ( cc: [ #1..#9,#11..#255 ]; s: 151),
  ( cc: [ #10 ]; s: 152),
{ 152: }
{ 153: }
  ( cc: [ ' ' ]; s: 172),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 154: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 141),
  ( cc: [ #10 ]; s: 161),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 154),
  ( cc: [ '>' ]; s: 173),
{ 155: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 142),
  ( cc: [ #10 ]; s: 162),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 155),
  ( cc: [ '>' ]; s: 174),
{ 156: }
  ( cc: [ ' ' ]; s: 175),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 157: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'d','f'..'z',
            #128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
  ( cc: [ 'e' ]; s: 176),
{ 158: }
  ( cc: [ #1..#9,#11..#255 ]; s: 158),
  ( cc: [ #10 ]; s: 177),
{ 159: }
{ 160: }
  ( cc: [ #1..#9,#11..#255 ]; s: 160),
  ( cc: [ #10 ]; s: 178),
{ 161: }
{ 162: }
{ 163: }
  ( cc: [ #1..#9,#11..#255 ]; s: 163),
  ( cc: [ #10 ]; s: 179),
{ 164: }
  ( cc: [ ' ' ]; s: 180),
{ 165: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 181),
  ( cc: [ #10 ]; s: 182),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 165),
{ 166: }
  ( cc: [ #1..#9,#11..#255 ]; s: 166),
  ( cc: [ #10 ]; s: 167),
{ 167: }
{ 168: }
  ( cc: [ #1..#9,#11..#255 ]; s: 168),
  ( cc: [ #10 ]; s: 169),
{ 169: }
{ 170: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 183),
  ( cc: [ #10 ]; s: 184),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 170),
{ 171: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' ' ]; s: 185),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 172: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 160),
  ( cc: [ #10 ]; s: 178),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 172),
  ( cc: [ '>' ]; s: 186),
{ 173: }
  ( cc: [ #1..#9,#11..#255 ]; s: 173),
  ( cc: [ #10 ]; s: 187),
{ 174: }
  ( cc: [ #1..#9,#11..#255 ]; s: 174),
  ( cc: [ #10 ]; s: 188),
{ 175: }
  ( cc: [ #1..#9,#11..#31,':'..'=','?','@','[',']','^',
            '`','{'..#127,#240..#255 ]; s: 163),
  ( cc: [ #10 ]; s: 179),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 175),
  ( cc: [ '>' ]; s: 189),
{ 176: }
  ( cc: [ ' ' ]; s: 190),
  ( cc: [ '!'..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44),
{ 177: }
{ 178: }
{ 179: }
{ 180: }
{ 181: }
  ( cc: [ #1..#9,#11..#255 ]; s: 181),
  ( cc: [ #10 ]; s: 182),
{ 182: }
{ 183: }
  ( cc: [ #1..#9,#11..#255 ]; s: 183),
  ( cc: [ #10 ]; s: 184),
{ 184: }
{ 185: }
  ( cc: [ #1..#9,#11..#31,':'..'@','[',']','^','`',
            '{'..#127,#240..#255 ]; s: 35),
  ( cc: [ #10 ]; s: 36),
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 34),
{ 186: }
  ( cc: [ #1..#9,#11..#255 ]; s: 186),
  ( cc: [ #10 ]; s: 191),
{ 187: }
{ 188: }
{ 189: }
  ( cc: [ #1..#9,#11..#255 ]; s: 189),
  ( cc: [ #10 ]; s: 192),
{ 190: }
  ( cc: [ ' '..'9','A'..'Z','\','_','a'..'z',#128..#239 ]; s: 43),
  ( cc: [ '>' ]; s: 44)
{ 191: }
{ 192: }
);

yykl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 1,
{ 4: } 1,
{ 5: } 1,
{ 6: } 1,
{ 7: } 1,
{ 8: } 1,
{ 9: } 1,
{ 10: } 1,
{ 11: } 2,
{ 12: } 3,
{ 13: } 4,
{ 14: } 6,
{ 15: } 8,
{ 16: } 9,
{ 17: } 10,
{ 18: } 11,
{ 19: } 12,
{ 20: } 13,
{ 21: } 14,
{ 22: } 16,
{ 23: } 18,
{ 24: } 20,
{ 25: } 21,
{ 26: } 23,
{ 27: } 23,
{ 28: } 24,
{ 29: } 24,
{ 30: } 24,
{ 31: } 24,
{ 32: } 24,
{ 33: } 24,
{ 34: } 25,
{ 35: } 25,
{ 36: } 25,
{ 37: } 26,
{ 38: } 26,
{ 39: } 26,
{ 40: } 26,
{ 41: } 26,
{ 42: } 26,
{ 43: } 27,
{ 44: } 27,
{ 45: } 27,
{ 46: } 27,
{ 47: } 27,
{ 48: } 27,
{ 49: } 27,
{ 50: } 29,
{ 51: } 30,
{ 52: } 31,
{ 53: } 31,
{ 54: } 31,
{ 55: } 31,
{ 56: } 31,
{ 57: } 31,
{ 58: } 31,
{ 59: } 31,
{ 60: } 33,
{ 61: } 33,
{ 62: } 33,
{ 63: } 33,
{ 64: } 33,
{ 65: } 33,
{ 66: } 33,
{ 67: } 33,
{ 68: } 34,
{ 69: } 34,
{ 70: } 34,
{ 71: } 34,
{ 72: } 34,
{ 73: } 34,
{ 74: } 34,
{ 75: } 35,
{ 76: } 35,
{ 77: } 35,
{ 78: } 35,
{ 79: } 35,
{ 80: } 35,
{ 81: } 35,
{ 82: } 35,
{ 83: } 35,
{ 84: } 35,
{ 85: } 35,
{ 86: } 35,
{ 87: } 35,
{ 88: } 35,
{ 89: } 35,
{ 90: } 37,
{ 91: } 37,
{ 92: } 37,
{ 93: } 37,
{ 94: } 37,
{ 95: } 37,
{ 96: } 37,
{ 97: } 37,
{ 98: } 37,
{ 99: } 37,
{ 100: } 37,
{ 101: } 37,
{ 102: } 37,
{ 103: } 37,
{ 104: } 37,
{ 105: } 37,
{ 106: } 37,
{ 107: } 37,
{ 108: } 37,
{ 109: } 37,
{ 110: } 37,
{ 111: } 37,
{ 112: } 37,
{ 113: } 37,
{ 114: } 37,
{ 115: } 37,
{ 116: } 37,
{ 117: } 37,
{ 118: } 37,
{ 119: } 37,
{ 120: } 37,
{ 121: } 37,
{ 122: } 37,
{ 123: } 37,
{ 124: } 37,
{ 125: } 38,
{ 126: } 38,
{ 127: } 38,
{ 128: } 38,
{ 129: } 38,
{ 130: } 38,
{ 131: } 38,
{ 132: } 38,
{ 133: } 40,
{ 134: } 40,
{ 135: } 40,
{ 136: } 40,
{ 137: } 40,
{ 138: } 40,
{ 139: } 40,
{ 140: } 40,
{ 141: } 40,
{ 142: } 40,
{ 143: } 40,
{ 144: } 40,
{ 145: } 40,
{ 146: } 41,
{ 147: } 41,
{ 148: } 41,
{ 149: } 41,
{ 150: } 41,
{ 151: } 41,
{ 152: } 41,
{ 153: } 43,
{ 154: } 43,
{ 155: } 43,
{ 156: } 43,
{ 157: } 43,
{ 158: } 43,
{ 159: } 43,
{ 160: } 45,
{ 161: } 45,
{ 162: } 46,
{ 163: } 47,
{ 164: } 47,
{ 165: } 47,
{ 166: } 47,
{ 167: } 47,
{ 168: } 49,
{ 169: } 49,
{ 170: } 51,
{ 171: } 51,
{ 172: } 51,
{ 173: } 51,
{ 174: } 51,
{ 175: } 51,
{ 176: } 51,
{ 177: } 51,
{ 178: } 53,
{ 179: } 54,
{ 180: } 55,
{ 181: } 56,
{ 182: } 56,
{ 183: } 58,
{ 184: } 58,
{ 185: } 60,
{ 186: } 61,
{ 187: } 61,
{ 188: } 63,
{ 189: } 65,
{ 190: } 65,
{ 191: } 66,
{ 192: } 68
);

yykh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } 0,
{ 4: } 0,
{ 5: } 0,
{ 6: } 0,
{ 7: } 0,
{ 8: } 0,
{ 9: } 0,
{ 10: } 1,
{ 11: } 2,
{ 12: } 3,
{ 13: } 5,
{ 14: } 7,
{ 15: } 8,
{ 16: } 9,
{ 17: } 10,
{ 18: } 11,
{ 19: } 12,
{ 20: } 13,
{ 21: } 15,
{ 22: } 17,
{ 23: } 19,
{ 24: } 20,
{ 25: } 22,
{ 26: } 22,
{ 27: } 23,
{ 28: } 23,
{ 29: } 23,
{ 30: } 23,
{ 31: } 23,
{ 32: } 23,
{ 33: } 24,
{ 34: } 24,
{ 35: } 24,
{ 36: } 25,
{ 37: } 25,
{ 38: } 25,
{ 39: } 25,
{ 40: } 25,
{ 41: } 25,
{ 42: } 26,
{ 43: } 26,
{ 44: } 26,
{ 45: } 26,
{ 46: } 26,
{ 47: } 26,
{ 48: } 26,
{ 49: } 28,
{ 50: } 29,
{ 51: } 30,
{ 52: } 30,
{ 53: } 30,
{ 54: } 30,
{ 55: } 30,
{ 56: } 30,
{ 57: } 30,
{ 58: } 30,
{ 59: } 32,
{ 60: } 32,
{ 61: } 32,
{ 62: } 32,
{ 63: } 32,
{ 64: } 32,
{ 65: } 32,
{ 66: } 32,
{ 67: } 33,
{ 68: } 33,
{ 69: } 33,
{ 70: } 33,
{ 71: } 33,
{ 72: } 33,
{ 73: } 33,
{ 74: } 34,
{ 75: } 34,
{ 76: } 34,
{ 77: } 34,
{ 78: } 34,
{ 79: } 34,
{ 80: } 34,
{ 81: } 34,
{ 82: } 34,
{ 83: } 34,
{ 84: } 34,
{ 85: } 34,
{ 86: } 34,
{ 87: } 34,
{ 88: } 34,
{ 89: } 36,
{ 90: } 36,
{ 91: } 36,
{ 92: } 36,
{ 93: } 36,
{ 94: } 36,
{ 95: } 36,
{ 96: } 36,
{ 97: } 36,
{ 98: } 36,
{ 99: } 36,
{ 100: } 36,
{ 101: } 36,
{ 102: } 36,
{ 103: } 36,
{ 104: } 36,
{ 105: } 36,
{ 106: } 36,
{ 107: } 36,
{ 108: } 36,
{ 109: } 36,
{ 110: } 36,
{ 111: } 36,
{ 112: } 36,
{ 113: } 36,
{ 114: } 36,
{ 115: } 36,
{ 116: } 36,
{ 117: } 36,
{ 118: } 36,
{ 119: } 36,
{ 120: } 36,
{ 121: } 36,
{ 122: } 36,
{ 123: } 36,
{ 124: } 37,
{ 125: } 37,
{ 126: } 37,
{ 127: } 37,
{ 128: } 37,
{ 129: } 37,
{ 130: } 37,
{ 131: } 37,
{ 132: } 39,
{ 133: } 39,
{ 134: } 39,
{ 135: } 39,
{ 136: } 39,
{ 137: } 39,
{ 138: } 39,
{ 139: } 39,
{ 140: } 39,
{ 141: } 39,
{ 142: } 39,
{ 143: } 39,
{ 144: } 39,
{ 145: } 40,
{ 146: } 40,
{ 147: } 40,
{ 148: } 40,
{ 149: } 40,
{ 150: } 40,
{ 151: } 40,
{ 152: } 42,
{ 153: } 42,
{ 154: } 42,
{ 155: } 42,
{ 156: } 42,
{ 157: } 42,
{ 158: } 42,
{ 159: } 44,
{ 160: } 44,
{ 161: } 45,
{ 162: } 46,
{ 163: } 46,
{ 164: } 46,
{ 165: } 46,
{ 166: } 46,
{ 167: } 48,
{ 168: } 48,
{ 169: } 50,
{ 170: } 50,
{ 171: } 50,
{ 172: } 50,
{ 173: } 50,
{ 174: } 50,
{ 175: } 50,
{ 176: } 50,
{ 177: } 52,
{ 178: } 53,
{ 179: } 54,
{ 180: } 55,
{ 181: } 55,
{ 182: } 57,
{ 183: } 57,
{ 184: } 59,
{ 185: } 60,
{ 186: } 60,
{ 187: } 62,
{ 188: } 64,
{ 189: } 64,
{ 190: } 65,
{ 191: } 67,
{ 192: } 69
);

yyml : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 1,
{ 4: } 1,
{ 5: } 1,
{ 6: } 1,
{ 7: } 1,
{ 8: } 1,
{ 9: } 1,
{ 10: } 1,
{ 11: } 2,
{ 12: } 3,
{ 13: } 4,
{ 14: } 6,
{ 15: } 8,
{ 16: } 9,
{ 17: } 10,
{ 18: } 11,
{ 19: } 12,
{ 20: } 13,
{ 21: } 14,
{ 22: } 16,
{ 23: } 18,
{ 24: } 20,
{ 25: } 21,
{ 26: } 23,
{ 27: } 23,
{ 28: } 24,
{ 29: } 24,
{ 30: } 24,
{ 31: } 24,
{ 32: } 24,
{ 33: } 24,
{ 34: } 25,
{ 35: } 25,
{ 36: } 25,
{ 37: } 26,
{ 38: } 26,
{ 39: } 26,
{ 40: } 26,
{ 41: } 26,
{ 42: } 26,
{ 43: } 27,
{ 44: } 27,
{ 45: } 27,
{ 46: } 27,
{ 47: } 27,
{ 48: } 27,
{ 49: } 27,
{ 50: } 29,
{ 51: } 30,
{ 52: } 31,
{ 53: } 31,
{ 54: } 31,
{ 55: } 31,
{ 56: } 31,
{ 57: } 31,
{ 58: } 31,
{ 59: } 31,
{ 60: } 33,
{ 61: } 33,
{ 62: } 33,
{ 63: } 33,
{ 64: } 33,
{ 65: } 33,
{ 66: } 33,
{ 67: } 33,
{ 68: } 34,
{ 69: } 34,
{ 70: } 34,
{ 71: } 34,
{ 72: } 34,
{ 73: } 34,
{ 74: } 34,
{ 75: } 35,
{ 76: } 35,
{ 77: } 35,
{ 78: } 35,
{ 79: } 35,
{ 80: } 35,
{ 81: } 35,
{ 82: } 35,
{ 83: } 35,
{ 84: } 35,
{ 85: } 35,
{ 86: } 35,
{ 87: } 35,
{ 88: } 35,
{ 89: } 35,
{ 90: } 37,
{ 91: } 37,
{ 92: } 37,
{ 93: } 37,
{ 94: } 37,
{ 95: } 37,
{ 96: } 37,
{ 97: } 37,
{ 98: } 37,
{ 99: } 37,
{ 100: } 37,
{ 101: } 37,
{ 102: } 37,
{ 103: } 37,
{ 104: } 37,
{ 105: } 37,
{ 106: } 37,
{ 107: } 37,
{ 108: } 37,
{ 109: } 37,
{ 110: } 37,
{ 111: } 37,
{ 112: } 37,
{ 113: } 37,
{ 114: } 37,
{ 115: } 37,
{ 116: } 37,
{ 117: } 37,
{ 118: } 37,
{ 119: } 37,
{ 120: } 37,
{ 121: } 37,
{ 122: } 37,
{ 123: } 37,
{ 124: } 37,
{ 125: } 38,
{ 126: } 38,
{ 127: } 38,
{ 128: } 38,
{ 129: } 38,
{ 130: } 38,
{ 131: } 38,
{ 132: } 38,
{ 133: } 40,
{ 134: } 40,
{ 135: } 40,
{ 136: } 40,
{ 137: } 40,
{ 138: } 40,
{ 139: } 40,
{ 140: } 40,
{ 141: } 40,
{ 142: } 40,
{ 143: } 40,
{ 144: } 40,
{ 145: } 40,
{ 146: } 41,
{ 147: } 41,
{ 148: } 41,
{ 149: } 41,
{ 150: } 41,
{ 151: } 41,
{ 152: } 41,
{ 153: } 43,
{ 154: } 43,
{ 155: } 43,
{ 156: } 43,
{ 157: } 43,
{ 158: } 43,
{ 159: } 43,
{ 160: } 45,
{ 161: } 45,
{ 162: } 46,
{ 163: } 47,
{ 164: } 47,
{ 165: } 47,
{ 166: } 47,
{ 167: } 47,
{ 168: } 49,
{ 169: } 49,
{ 170: } 51,
{ 171: } 51,
{ 172: } 51,
{ 173: } 51,
{ 174: } 51,
{ 175: } 51,
{ 176: } 51,
{ 177: } 51,
{ 178: } 53,
{ 179: } 54,
{ 180: } 55,
{ 181: } 56,
{ 182: } 56,
{ 183: } 58,
{ 184: } 58,
{ 185: } 60,
{ 186: } 61,
{ 187: } 61,
{ 188: } 63,
{ 189: } 65,
{ 190: } 65,
{ 191: } 66,
{ 192: } 68
);

yymh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } 0,
{ 4: } 0,
{ 5: } 0,
{ 6: } 0,
{ 7: } 0,
{ 8: } 0,
{ 9: } 0,
{ 10: } 1,
{ 11: } 2,
{ 12: } 3,
{ 13: } 5,
{ 14: } 7,
{ 15: } 8,
{ 16: } 9,
{ 17: } 10,
{ 18: } 11,
{ 19: } 12,
{ 20: } 13,
{ 21: } 15,
{ 22: } 17,
{ 23: } 19,
{ 24: } 20,
{ 25: } 22,
{ 26: } 22,
{ 27: } 23,
{ 28: } 23,
{ 29: } 23,
{ 30: } 23,
{ 31: } 23,
{ 32: } 23,
{ 33: } 24,
{ 34: } 24,
{ 35: } 24,
{ 36: } 25,
{ 37: } 25,
{ 38: } 25,
{ 39: } 25,
{ 40: } 25,
{ 41: } 25,
{ 42: } 26,
{ 43: } 26,
{ 44: } 26,
{ 45: } 26,
{ 46: } 26,
{ 47: } 26,
{ 48: } 26,
{ 49: } 28,
{ 50: } 29,
{ 51: } 30,
{ 52: } 30,
{ 53: } 30,
{ 54: } 30,
{ 55: } 30,
{ 56: } 30,
{ 57: } 30,
{ 58: } 30,
{ 59: } 32,
{ 60: } 32,
{ 61: } 32,
{ 62: } 32,
{ 63: } 32,
{ 64: } 32,
{ 65: } 32,
{ 66: } 32,
{ 67: } 33,
{ 68: } 33,
{ 69: } 33,
{ 70: } 33,
{ 71: } 33,
{ 72: } 33,
{ 73: } 33,
{ 74: } 34,
{ 75: } 34,
{ 76: } 34,
{ 77: } 34,
{ 78: } 34,
{ 79: } 34,
{ 80: } 34,
{ 81: } 34,
{ 82: } 34,
{ 83: } 34,
{ 84: } 34,
{ 85: } 34,
{ 86: } 34,
{ 87: } 34,
{ 88: } 34,
{ 89: } 36,
{ 90: } 36,
{ 91: } 36,
{ 92: } 36,
{ 93: } 36,
{ 94: } 36,
{ 95: } 36,
{ 96: } 36,
{ 97: } 36,
{ 98: } 36,
{ 99: } 36,
{ 100: } 36,
{ 101: } 36,
{ 102: } 36,
{ 103: } 36,
{ 104: } 36,
{ 105: } 36,
{ 106: } 36,
{ 107: } 36,
{ 108: } 36,
{ 109: } 36,
{ 110: } 36,
{ 111: } 36,
{ 112: } 36,
{ 113: } 36,
{ 114: } 36,
{ 115: } 36,
{ 116: } 36,
{ 117: } 36,
{ 118: } 36,
{ 119: } 36,
{ 120: } 36,
{ 121: } 36,
{ 122: } 36,
{ 123: } 36,
{ 124: } 37,
{ 125: } 37,
{ 126: } 37,
{ 127: } 37,
{ 128: } 37,
{ 129: } 37,
{ 130: } 37,
{ 131: } 37,
{ 132: } 39,
{ 133: } 39,
{ 134: } 39,
{ 135: } 39,
{ 136: } 39,
{ 137: } 39,
{ 138: } 39,
{ 139: } 39,
{ 140: } 39,
{ 141: } 39,
{ 142: } 39,
{ 143: } 39,
{ 144: } 39,
{ 145: } 40,
{ 146: } 40,
{ 147: } 40,
{ 148: } 40,
{ 149: } 40,
{ 150: } 40,
{ 151: } 40,
{ 152: } 42,
{ 153: } 42,
{ 154: } 42,
{ 155: } 42,
{ 156: } 42,
{ 157: } 42,
{ 158: } 42,
{ 159: } 44,
{ 160: } 44,
{ 161: } 45,
{ 162: } 46,
{ 163: } 46,
{ 164: } 46,
{ 165: } 46,
{ 166: } 46,
{ 167: } 48,
{ 168: } 48,
{ 169: } 50,
{ 170: } 50,
{ 171: } 50,
{ 172: } 50,
{ 173: } 50,
{ 174: } 50,
{ 175: } 50,
{ 176: } 50,
{ 177: } 52,
{ 178: } 53,
{ 179: } 54,
{ 180: } 55,
{ 181: } 55,
{ 182: } 57,
{ 183: } 57,
{ 184: } 59,
{ 185: } 60,
{ 186: } 60,
{ 187: } 62,
{ 188: } 64,
{ 189: } 64,
{ 190: } 65,
{ 191: } 67,
{ 192: } 69
);

yytl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 3,
{ 2: } 6,
{ 3: } 10,
{ 4: } 15,
{ 5: } 18,
{ 6: } 22,
{ 7: } 25,
{ 8: } 29,
{ 9: } 33,
{ 10: } 38,
{ 11: } 40,
{ 12: } 40,
{ 13: } 44,
{ 14: } 44,
{ 15: } 44,
{ 16: } 49,
{ 17: } 52,
{ 18: } 59,
{ 19: } 63,
{ 20: } 65,
{ 21: } 71,
{ 22: } 73,
{ 23: } 74,
{ 24: } 74,
{ 25: } 74,
{ 26: } 78,
{ 27: } 80,
{ 28: } 80,
{ 29: } 81,
{ 30: } 82,
{ 31: } 84,
{ 32: } 86,
{ 33: } 89,
{ 34: } 92,
{ 35: } 95,
{ 36: } 97,
{ 37: } 97,
{ 38: } 101,
{ 39: } 105,
{ 40: } 110,
{ 41: } 115,
{ 42: } 119,
{ 43: } 121,
{ 44: } 123,
{ 45: } 125,
{ 46: } 128,
{ 47: } 131,
{ 48: } 135,
{ 49: } 139,
{ 50: } 139,
{ 51: } 140,
{ 52: } 140,
{ 53: } 141,
{ 54: } 142,
{ 55: } 144,
{ 56: } 145,
{ 57: } 146,
{ 58: } 147,
{ 59: } 149,
{ 60: } 149,
{ 61: } 153,
{ 62: } 157,
{ 63: } 162,
{ 64: } 166,
{ 65: } 170,
{ 66: } 174,
{ 67: } 176,
{ 68: } 176,
{ 69: } 179,
{ 70: } 182,
{ 71: } 186,
{ 72: } 189,
{ 73: } 192,
{ 74: } 195,
{ 75: } 195,
{ 76: } 196,
{ 77: } 197,
{ 78: } 198,
{ 79: } 199,
{ 80: } 200,
{ 81: } 201,
{ 82: } 202,
{ 83: } 206,
{ 84: } 210,
{ 85: } 214,
{ 86: } 218,
{ 87: } 222,
{ 88: } 226,
{ 89: } 230,
{ 90: } 230,
{ 91: } 233,
{ 92: } 236,
{ 93: } 239,
{ 94: } 242,
{ 95: } 245,
{ 96: } 248,
{ 97: } 251,
{ 98: } 252,
{ 99: } 253,
{ 100: } 254,
{ 101: } 255,
{ 102: } 256,
{ 103: } 257,
{ 104: } 259,
{ 105: } 263,
{ 106: } 267,
{ 107: } 271,
{ 108: } 275,
{ 109: } 279,
{ 110: } 283,
{ 111: } 286,
{ 112: } 289,
{ 113: } 292,
{ 114: } 295,
{ 115: } 298,
{ 116: } 301,
{ 117: } 304,
{ 118: } 308,
{ 119: } 309,
{ 120: } 310,
{ 121: } 311,
{ 122: } 312,
{ 123: } 313,
{ 124: } 315,
{ 125: } 315,
{ 126: } 319,
{ 127: } 323,
{ 128: } 327,
{ 129: } 331,
{ 130: } 335,
{ 131: } 338,
{ 132: } 340,
{ 133: } 340,
{ 134: } 343,
{ 135: } 346,
{ 136: } 349,
{ 137: } 352,
{ 138: } 355,
{ 139: } 359,
{ 140: } 361,
{ 141: } 362,
{ 142: } 364,
{ 143: } 366,
{ 144: } 367,
{ 145: } 368,
{ 146: } 368,
{ 147: } 372,
{ 148: } 375,
{ 149: } 378,
{ 150: } 382,
{ 151: } 386,
{ 152: } 388,
{ 153: } 388,
{ 154: } 391,
{ 155: } 395,
{ 156: } 399,
{ 157: } 402,
{ 158: } 405,
{ 159: } 407,
{ 160: } 407,
{ 161: } 409,
{ 162: } 409,
{ 163: } 409,
{ 164: } 411,
{ 165: } 412,
{ 166: } 415,
{ 167: } 417,
{ 168: } 417,
{ 169: } 419,
{ 170: } 419,
{ 171: } 422,
{ 172: } 426,
{ 173: } 430,
{ 174: } 432,
{ 175: } 434,
{ 176: } 438,
{ 177: } 441,
{ 178: } 441,
{ 179: } 441,
{ 180: } 441,
{ 181: } 441,
{ 182: } 443,
{ 183: } 443,
{ 184: } 445,
{ 185: } 445,
{ 186: } 448,
{ 187: } 450,
{ 188: } 450,
{ 189: } 450,
{ 190: } 452,
{ 191: } 454,
{ 192: } 454
);

yyth : array [0..yynstates-1] of Integer = (
{ 0: } 2,
{ 1: } 5,
{ 2: } 9,
{ 3: } 14,
{ 4: } 17,
{ 5: } 21,
{ 6: } 24,
{ 7: } 28,
{ 8: } 32,
{ 9: } 37,
{ 10: } 39,
{ 11: } 39,
{ 12: } 43,
{ 13: } 43,
{ 14: } 43,
{ 15: } 48,
{ 16: } 51,
{ 17: } 58,
{ 18: } 62,
{ 19: } 64,
{ 20: } 70,
{ 21: } 72,
{ 22: } 73,
{ 23: } 73,
{ 24: } 73,
{ 25: } 77,
{ 26: } 79,
{ 27: } 79,
{ 28: } 80,
{ 29: } 81,
{ 30: } 83,
{ 31: } 85,
{ 32: } 88,
{ 33: } 91,
{ 34: } 94,
{ 35: } 96,
{ 36: } 96,
{ 37: } 100,
{ 38: } 104,
{ 39: } 109,
{ 40: } 114,
{ 41: } 118,
{ 42: } 120,
{ 43: } 122,
{ 44: } 124,
{ 45: } 127,
{ 46: } 130,
{ 47: } 134,
{ 48: } 138,
{ 49: } 138,
{ 50: } 139,
{ 51: } 139,
{ 52: } 140,
{ 53: } 141,
{ 54: } 143,
{ 55: } 144,
{ 56: } 145,
{ 57: } 146,
{ 58: } 148,
{ 59: } 148,
{ 60: } 152,
{ 61: } 156,
{ 62: } 161,
{ 63: } 165,
{ 64: } 169,
{ 65: } 173,
{ 66: } 175,
{ 67: } 175,
{ 68: } 178,
{ 69: } 181,
{ 70: } 185,
{ 71: } 188,
{ 72: } 191,
{ 73: } 194,
{ 74: } 194,
{ 75: } 195,
{ 76: } 196,
{ 77: } 197,
{ 78: } 198,
{ 79: } 199,
{ 80: } 200,
{ 81: } 201,
{ 82: } 205,
{ 83: } 209,
{ 84: } 213,
{ 85: } 217,
{ 86: } 221,
{ 87: } 225,
{ 88: } 229,
{ 89: } 229,
{ 90: } 232,
{ 91: } 235,
{ 92: } 238,
{ 93: } 241,
{ 94: } 244,
{ 95: } 247,
{ 96: } 250,
{ 97: } 251,
{ 98: } 252,
{ 99: } 253,
{ 100: } 254,
{ 101: } 255,
{ 102: } 256,
{ 103: } 258,
{ 104: } 262,
{ 105: } 266,
{ 106: } 270,
{ 107: } 274,
{ 108: } 278,
{ 109: } 282,
{ 110: } 285,
{ 111: } 288,
{ 112: } 291,
{ 113: } 294,
{ 114: } 297,
{ 115: } 300,
{ 116: } 303,
{ 117: } 307,
{ 118: } 308,
{ 119: } 309,
{ 120: } 310,
{ 121: } 311,
{ 122: } 312,
{ 123: } 314,
{ 124: } 314,
{ 125: } 318,
{ 126: } 322,
{ 127: } 326,
{ 128: } 330,
{ 129: } 334,
{ 130: } 337,
{ 131: } 339,
{ 132: } 339,
{ 133: } 342,
{ 134: } 345,
{ 135: } 348,
{ 136: } 351,
{ 137: } 354,
{ 138: } 358,
{ 139: } 360,
{ 140: } 361,
{ 141: } 363,
{ 142: } 365,
{ 143: } 366,
{ 144: } 367,
{ 145: } 367,
{ 146: } 371,
{ 147: } 374,
{ 148: } 377,
{ 149: } 381,
{ 150: } 385,
{ 151: } 387,
{ 152: } 387,
{ 153: } 390,
{ 154: } 394,
{ 155: } 398,
{ 156: } 401,
{ 157: } 404,
{ 158: } 406,
{ 159: } 406,
{ 160: } 408,
{ 161: } 408,
{ 162: } 408,
{ 163: } 410,
{ 164: } 411,
{ 165: } 414,
{ 166: } 416,
{ 167: } 416,
{ 168: } 418,
{ 169: } 418,
{ 170: } 421,
{ 171: } 425,
{ 172: } 429,
{ 173: } 431,
{ 174: } 433,
{ 175: } 437,
{ 176: } 440,
{ 177: } 440,
{ 178: } 440,
{ 179: } 440,
{ 180: } 440,
{ 181: } 442,
{ 182: } 442,
{ 183: } 444,
{ 184: } 444,
{ 185: } 447,
{ 186: } 449,
{ 187: } 449,
{ 188: } 449,
{ 189: } 451,
{ 190: } 453,
{ 191: } 453,
{ 192: } 453
);


var yyn : Integer;

label start, scan, action;

begin

start:

  (* initialize: *)

  yynew;

scan:

  (* mark positions and matches: *)

  for yyn := yykl[yystate] to     yykh[yystate] do yymark(yyk[yyn]);
  for yyn := yymh[yystate] downto yyml[yystate] do yymatch(yym[yyn]);

  if yytl[yystate]>yyth[yystate] then goto action; (* dead state *)

  (* get next character: *)

  yyscan;

  (* determine action: *)

  yyn := yytl[yystate];
  while (yyn<=yyth[yystate]) and not (yyactchar in yyt[yyn].cc) do inc(yyn);
  if yyn>yyth[yystate] then goto action;
    (* no transition on yyactchar in this state *)

  (* switch to new state: *)

  yystate := yyt[yyn].s;

  goto scan;

action:

  (* execute action: *)

  if yyfind(yyrule) then
    begin
      yyaction(yyrule);
      if yyreject then goto action;
    end
  else if not yydefault and yywrap then
    begin
      yyclear;
      return(0);
    end;

  if not yydone then goto start;

  yylex := yyretval;

end(*yylex*);



function enabled: Boolean;
begin
  result := _enabled[stack_pos] and (disabled_at = -1);
end;

procedure _define(val: string);
begin
  if not enabled then exit;
  defined.values[val] := 'TRUE';
  yyprintln;
end;

procedure _undef(val: string);
begin
  if not enabled then exit;
  defined.values[val] := '';
  yyprintln;
end;

procedure _ifdef(val: string);
begin
  inc(stack_pos);
  _enabled[stack_pos] := defined.values[val] = 'TRUE';
  if not _enabled[stack_pos] then disabled_at := stack_pos;
  yyprintln;
end;

procedure _ifndef(val: string);
begin
  inc(stack_pos);
  _enabled[stack_pos] := defined.values[val] = '';
  if not _enabled[stack_pos] then disabled_at := stack_pos;
  yyprintln;
end;

procedure _else;
begin
  _enabled[stack_pos] := not _enabled[stack_pos];
  if not _enabled[stack_pos] then
    disabled_at := stack_pos
  else if disabled_at = stack_pos then
    disabled_at := -1;
  yyprintln;
end;

procedure _endif;
begin
  if disabled_at = stack_pos then
    disabled_at := -1;
  dec(stack_pos);
  yyprintln;
end;

procedure _print;
begin
  if enabled then
     put_char(yytext[1]);
end;

procedure include_file(const fname: string; local: boolean);
var
  i : integer;
  found: Boolean;
  old_yyinput : TStream;
  old_yyline  : String;
  old_yylineno, old_yycolno : Integer;
  old_yytext  : ShortString;
  old_yyleng  : Byte;
  old_yystate    : Integer;
  old_yyactchar  : Char;
  old_yylastchar : Char;
  old_yyrule     : Integer;
  old_yyreject   : Boolean;
  old_yydone     : Boolean;
  old_yyretval   : Integer;
  old_filename,real_file_name : string;

  function _ExtractFilePath(path: string): string;
  var
    I: Integer;
  begin
    I := LastDelimiter('\:/', FileName);
    Result := Copy(FileName, 1, I);
  end;

  function _IncludeTrailingBackslash(path: string): string;
  begin
    result := path;
    if trim(path) = '' then exit;
    if (path[Length(path)] <> '/') and (path[Length(path)] <> '\') then
      result := path + '\'
  end;

begin
  if not enabled then
    begin
      yyprintln;
      exit;
    end;
  real_file_name := fname;
  if not fileexists(fname) then
    begin
      if local then
        begin
          real_file_name := _IncludeTrailingBackslash(_ExtractFilePath(filename))+fname;
          if not FileExists(real_file_name) then
            PrintError('file not found "'+fname+'"');
        end
      else
        begin
          found := false;
          for i := 0 to pred(includes.count) do
            begin
              real_file_name := _IncludeTrailingBackslash(includes[i])+fname;
              if fileexists(real_file_name) then
                begin
                  found := true;
                  break;
                end;
            end;
          if not found then
            PrintError('file not found "'+fname+'"')
        end;
    end;
  old_yyinput := yyinput;
  old_yyline  := yyline;
  old_yylineno := yylineno;
  old_yycolno := yycolno;
  old_yytext  := yytext;
  old_yyleng  := yyleng;
  old_yystate  := yystate;
  old_yyactchar  := yyactchar;
  old_yylastchar := yylastchar;
  old_yyrule     := yyrule;
  old_yyreject   := yyreject;
  old_yydone     := yydone;
  old_yyretval   := yyretval;
  old_filename := filename;
  yyinput := TFileStream.Create(real_file_name,fmOpenRead);
  try
    filename := real_file_name;
    yylineno := 0;
    yycolno := 0;
    yystate := 0;
    yyclear;
    yyprintln('#line 1 "'+filename+'"');
    yylex;
  finally
    yyclear;
    yyinput.Free;
    filename := old_filename;
    yyinput := old_yyinput;
    yyline  := old_yyline;
    yylineno := old_yylineno;
    yycolno := old_yycolno;
    yytext  := old_yytext;
    yyleng  := old_yyleng;
    yystate  := old_yystate;
    yyactchar  := old_yyactchar;
    yylastchar := old_yylastchar;
    yyrule     := old_yyrule;
    yyreject   := old_yyreject;
    yydone     := old_yydone;
    yyretval   := old_yyretval;
    yyprintln('#line '+inttostr(yylineno+1)+' "'+filename+'"');
    start(0);
  end;
end;

initialization
  includes := TStringList.Create;
  defined  := TStringList.Create;
  stack_pos := 0;
  _enabled[stack_pos] := true;
  disabled_at := -1;
finalization
  includes.free;
  defined.free;
end.
